grammar Language4_AST;

options
{
   output=AST;
   ASTLabelType=CommonTree;
}

expression : exp // {System.out.println($exp.tree.toStringTree());}
           ;

exp : begin | var | nexp
    ;

begin : '(' 'begin' exp+ ')' -> ^( 'begin' exp+ )
      ;

var : '(' 'var' VARIABLE exp ')' -> ^( 'var' VARIABLE exp )
    ;

nexp : aexp | bexp
     | VARIABLE | INTEGER | BOOLEAN
     ;

aexp : '(' binOp nexp nexp ')' -> ^( binOp nexp nexp )
     | '(' '-' nexp nexp? ')'  -> ^( '-' nexp nexp? )
     ;

binOp : '+' | '*' | '/' | '%' | '^'
      ;

bexp : '(' boolOp nexp nexp ')' -> ^( boolOp nexp nexp )
     | '(' '!' nexp ')'         -> ^( '!' nexp )
     | '(' relOp nexp nexp ')'  -> ^( relOp nexp nexp )
     | '(' eqOp  nexp nexp ')'  -> ^( eqOp nexp nexp )
     ;

boolOp : '&&' | '||'
       ;

relOp : '<' | '>' | '<=' | '>='
      ;

eqOp : '==' | '!='
     ;

INTEGER : '0'..'9'+
        ;

BOOLEAN : 'false' | 'true'
        ;

VARIABLE : ('a'..'z'|'A'..'Z')+
         ;

WS : (' '|'\t'|'\n'|'\r')+ {skip();}
   ;

