/*
  This program tests the lexers and parsers created
  by Antlr from the grammars Language4.g.

  See the following page for information on using Antlr
  on the command line to create the lexer and parser, to
  compile the lexer and parser, and then to compile and
  run this program.
  http://www.antlr.org/wiki/pages/viewpage.action?pageId=729
*/
import org.antlr.runtime.*;


public class TestParser
{
   public static void main(String[] args)
   {
      String[] exprs =
      {
        "(begin " +
           "(begin (var x 2)" +
                    "(var y 2))" +
            "(var z (+ x y))" +
        ")",
        "(begin " +
           "(var x 4) " +
           "(begin (var y false)" +
                   "(|| y (== (+ 2 x) (* 2 3)))))",
        "( begin " +
           "(var x (begin (var z 2) (+ z z)))" +
            "(begin (var y false) " +
                   "(begin (var u 2) " +
                           "(begin " +
                              "(var v (|| y (== (+ u 4) (* u 3))))" +
                              "v))))",
        "(var x " +
           "(begin (var y 2)" +
                   "(var z (+ y 3))))",
        // illegal expressions
        "(var z (+ (var x (var y 2)) (+ y (* 3 x))))",
        "(begin (var x false ) (+ 1 x))",
        "(+ (!= (* 2 2) 5) (/ 1 0))"
      };

      for (int i = 0; i < exprs.length; i++)
      {
         Language4Lexer lexer = new Language4Lexer(new ANTLRStringStream(exprs[i]));
         Language4Parser parser = new Language4Parser(new CommonTokenStream(lexer));

         System.out.println( "Parsing: " + exprs[i] );
         try
         {
            parser.expression();
         }
         catch (Exception e)
         {
            System.out.println(e);
         }
         System.out.println("========================================");
      }
   }//main

}//TestParser
